diff -uwrN sourceold/scripts/tcw_coop.cpp source/scripts/tcw_coop.cpp
--- sourceold/scripts/tcw_coop.cpp	2012-06-09 08:11:12.123046800 +0800
+++ source/scripts/tcw_coop.cpp	2012-07-31 21:54:12.073242100 +0800
@@ -112,6 +112,54 @@
 	}
 }
 
+void tcw_goto_player_attack::Created(GameObject *obj)
+{
+    Commands->Start_Timer(obj, this, 3.500000, 20000);
+} 
+void tcw_goto_player_attack::Timer_Expired(GameObject *obj, int number)
+{
+    if(number == 20000)
+    {
+		GameObject *player = Commands->Get_A_Star(Commands->Get_Position(obj));
+		if (player)
+		{
+			ActionParamsStruct Params;
+			Params.Set_Basic(this,100,20000);
+			Params.Set_Movement(player,0.800000f,2.500000f);
+			Params.Set_Attack(player,50.000000f,1.000000f,true);
+			Commands->Action_Attack(obj,Params);
+			Commands->Start_Timer(obj,this,3.0f,20000);
+		}
+		else
+		{
+			player = 0;	Commands->Start_Timer(obj,this,3.0f,20000);
+		}
+	}
+}
+ 
+void tcw_goto_player::Created(GameObject *obj)
+{
+        Commands->Enable_Hibernation(obj,false);
+        Commands->Start_Timer(obj,this,5.0f,65);
+        ActionParamsStruct Params;
+        Params.Set_Basic(this,45,63);
+        Params.Set_Movement(Commands->Get_A_Star(Commands->Get_Position(obj)),1,0.8f);
+        Commands->Action_Goto(obj,Params);
+}
+void tcw_goto_player::Timer_Expired(GameObject *obj, int number)
+{
+        if (number == 65 && obj)
+        {
+                ActionParamsStruct Params;
+                Params.Set_Basic(this,45,63);
+                Params.Set_Movement(Commands->Get_A_Star(Commands->Get_Position(obj)),1,0.8f);
+                Commands->Action_Goto(obj,Params);
+                Commands->Start_Timer(obj,this,5.0f,65);
+        }
+}
+
+ScriptRegistrant<tcw_goto_player> tcw_goto_player_Registrant("tcw_goto_player","");
+ScriptRegistrant<tcw_goto_player_attack> tcw_goto_player_attack_Registrant("tcw_goto_player_attack","");
 ScriptRegistrant<tcw_midlight_eva1> tcw_midlight_eva1_Registrant("tcw_midlight_eva1","");
 ScriptRegistrant<tcw_enable_spawners_killed> tcw_enable_spawners_killed_Registrant("tcw_enable_spawners_killed","Enable=0:int,Spawner01=0:int,Spawner02=0:int,Spawner03=0:int,Spawner04=0:int,Spawner05=0:int,Spawner06=0:int,Spawner07=0:int,Spawner08=0:int,Spawner09=0:int,Spawner10=0:int,");
 ScriptRegistrant<tcw_attach_script_simple_timer> tcw_attach_script_simple_timer_Registrant("tcw_attach_script_simple_timer","Time=0:float,TimerID=100:int,Scriptname=bla:string");
diff -uwrN sourceold/scripts/tcw_coop.h source/scripts/tcw_coop.h
--- sourceold/scripts/tcw_coop.h	2012-06-09 08:11:12.191406200 +0800
+++ source/scripts/tcw_coop.h	2012-07-31 21:54:12.066406200 +0800
@@ -31,3 +31,15 @@
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj, int number);
 };
+
+class tcw_goto_player_attack : public ScriptImpClass
+{
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj, int number);
+};
+
+class tcw_goto_player : public ScriptImpClass
+{
+        void Created(GameObject *obj);
+        void Timer_Expired(GameObject *obj, int number);
+};
\ No newline at end of file
diff -uwrN sourceold/scripts/tcw_defence.cpp source/scripts/tcw_defence.cpp
--- sourceold/scripts/tcw_defence.cpp	2012-06-09 08:11:12.334960900 +0800
+++ source/scripts/tcw_defence.cpp	2012-07-31 21:54:12.054687500 +0800
@@ -37,6 +37,11 @@
 	Commands->Start_Timer(obj, this, attack_timer, 11);
 }
 
+void tcw_Base_Defense::Killed(GameObject *obj, GameObject *shooter)
+{
+	//placeholder	
+}
+
 void tcw_Base_Defense::Damaged(GameObject *obj, GameObject *damager, float amount)
 {
 	if (Is_Base_Powered(Get_Int_Parameter("Team")))
diff -uwrN sourceold/scripts/tcw_defence.h source/scripts/tcw_defence.h
--- sourceold/scripts/tcw_defence.h	2012-06-09 08:11:12.215820300 +0800
+++ source/scripts/tcw_defence.h	2012-07-31 21:54:12.128906200 +0800
@@ -31,5 +31,6 @@
 	void Damaged(GameObject *obj, GameObject *damager, float amount);
 	void Timer_Expired(GameObject *obj, int number);
 	void Action_Complete(GameObject *obj, int action_id, ActionCompleteReason complete_reason);
+	void Killed(GameObject *obj, GameObject *shooter);
 	public: void Register_Auto_Save_Variables();
 };
\ No newline at end of file
diff -uwrN sourceold/scripts/tcw_domination.cpp source/scripts/tcw_domination.cpp
--- sourceold/scripts/tcw_domination.cpp	2012-06-09 08:11:12.146484300 +0800
+++ source/scripts/tcw_domination.cpp	2012-07-31 21:54:12.189453100 +0800
@@ -224,6 +224,7 @@
 						Commands->Set_Facing(nodveh1,nodveh1fac);
 						nodveh1id = Commands->Get_ID(nodveh1);
 						Attach_Script_Once(nodveh1,"tcw_domination_vehicle","0");
+						Commands->Set_Player_Type(nodveh1,-2);
 					}
 				}
 				if (!Commands->Find_Object(nodveh2id))
@@ -236,6 +237,7 @@
 						Commands->Set_Facing(nodveh2,nodveh2fac);
 						nodveh2id = Commands->Get_ID(nodveh2);
 						Attach_Script_Once(nodveh2,"tcw_domination_vehicle","0");
+						Commands->Set_Player_Type(nodveh2,-2);
 					}
 				}
 				if (!Commands->Find_Object(nodveh3id))
@@ -248,6 +250,7 @@
 						Commands->Set_Facing(nodveh3,nodveh3fac);
 						nodveh3id = Commands->Get_ID(nodveh3);
 						Attach_Script_Once(nodveh3,"tcw_domination_vehicle","0");
+						Commands->Set_Player_Type(nodveh3,-2);
 					}
 				}
 				if (!Commands->Find_Object(nodveh4id))
@@ -260,6 +263,7 @@
 						Commands->Set_Facing(nodveh4,nodveh4fac);
 						nodveh4id = Commands->Get_ID(nodveh4);
 						Attach_Script_Once(nodveh4,"tcw_domination_vehicle","0");
+						Commands->Set_Player_Type(nodveh4,-2);
 					}
 				}
 				if (!Commands->Find_Object(nodveh5id))
@@ -272,6 +276,7 @@
 						Commands->Set_Facing(nodveh5,nodveh5fac);
 						nodveh5id = Commands->Get_ID(nodveh5);
 						Attach_Script_Once(nodveh5,"tcw_domination_vehicle","0");
+						Commands->Set_Player_Type(nodveh5,-2);
 					}
 				}
 
@@ -317,6 +322,7 @@
 						Commands->Set_Facing(gdiveh1,gdiveh1fac);
 						gdiveh1id = Commands->Get_ID(gdiveh1);
 						Attach_Script_Once(gdiveh1,"tcw_domination_vehicle","1");
+						Commands->Set_Player_Type(gdiveh1,-2);
 					}
 				}
 				if (!Commands->Find_Object(gdiveh2id))
@@ -329,6 +335,7 @@
 						Commands->Set_Facing(gdiveh2,gdiveh2fac);
 						gdiveh2id = Commands->Get_ID(gdiveh2);
 						Attach_Script_Once(gdiveh2,"tcw_domination_vehicle","1");
+						Commands->Set_Player_Type(gdiveh2,-2);
 					}
 				}
 				if (!Commands->Find_Object(gdiveh3id))
@@ -341,6 +348,7 @@
 						Commands->Set_Facing(gdiveh3,gdiveh3fac);
 						gdiveh3id = Commands->Get_ID(gdiveh3);
 						Attach_Script_Once(gdiveh3,"tcw_domination_vehicle","1");
+						Commands->Set_Player_Type(gdiveh3,-2);
 					}
 				}
 				if (!Commands->Find_Object(gdiveh4id))
@@ -353,6 +361,7 @@
 						Commands->Set_Facing(gdiveh4,gdiveh4fac);
 						gdiveh4id = Commands->Get_ID(gdiveh4);
 						Attach_Script_Once(gdiveh4,"tcw_domination_vehicle","1");
+						Commands->Set_Player_Type(gdiveh4,-2);
 					}
 				}
 				if (!Commands->Find_Object(gdiveh5id))
@@ -365,6 +374,7 @@
 						Commands->Set_Facing(gdiveh5,gdiveh5fac);
 						gdiveh5id = Commands->Get_ID(gdiveh5);
 						Attach_Script_Once(gdiveh5,"tcw_domination_vehicle","1");
+						Commands->Set_Player_Type(gdiveh5,-2);
 					}
 				}
 
@@ -462,6 +472,7 @@
 					Commands->Set_Facing(nodveh1,nodveh1fac);
 					nodveh1id = Commands->Get_ID(nodveh1);
 					Attach_Script_Once(nodveh1,"tcw_domination_vehicle","0");
+					Commands->Set_Player_Type(nodveh1,-2);
 				}
 			}
 			if (!Commands->Find_Object(nodveh2id))
@@ -474,6 +485,7 @@
 					Commands->Set_Facing(nodveh2,nodveh2fac);
 					nodveh2id = Commands->Get_ID(nodveh2);
 					Attach_Script_Once(nodveh2,"tcw_domination_vehicle","0");
+					Commands->Set_Player_Type(nodveh2,-2);
 				}
 			}
 			if (!Commands->Find_Object(nodveh3id))
@@ -486,6 +498,7 @@
 					Commands->Set_Facing(nodveh3,nodveh3fac);
 					nodveh3id = Commands->Get_ID(nodveh3);
 					Attach_Script_Once(nodveh3,"tcw_domination_vehicle","0");
+					Commands->Set_Player_Type(nodveh3,-2);
 				}
 			}
 			if (!Commands->Find_Object(nodveh4id))
@@ -498,6 +511,7 @@
 					Commands->Set_Facing(nodveh4,nodveh4fac);
 					nodveh4id = Commands->Get_ID(nodveh4);
 					Attach_Script_Once(nodveh4,"tcw_domination_vehicle","0");
+					Commands->Set_Player_Type(nodveh4,-2);
 				}
 			}
 			if (!Commands->Find_Object(nodveh5id))
@@ -510,6 +524,7 @@
 					Commands->Set_Facing(nodveh5,nodveh5fac);
 					nodveh5id = Commands->Get_ID(nodveh5);
 					Attach_Script_Once(nodveh5,"tcw_domination_vehicle","0");
+					Commands->Set_Player_Type(nodveh5,-2);
 				}
 			}
 		}
@@ -529,6 +544,7 @@
 					Commands->Set_Facing(gdiveh1,gdiveh1fac);
 					gdiveh1id = Commands->Get_ID(gdiveh1);
 					Attach_Script_Once(gdiveh1,"tcw_domination_vehicle","1");
+					Commands->Set_Player_Type(gdiveh1,-2);
 				}
 			}
 			if (!Commands->Find_Object(gdiveh2id))
@@ -541,6 +557,7 @@
 					Commands->Set_Facing(gdiveh2,gdiveh2fac);
 					gdiveh2id = Commands->Get_ID(gdiveh2);
 					Attach_Script_Once(gdiveh2,"tcw_domination_vehicle","1");
+					Commands->Set_Player_Type(gdiveh2,-2);
 				}
 			}
 			if (!Commands->Find_Object(gdiveh3id))
@@ -553,6 +570,7 @@
 					Commands->Set_Facing(gdiveh3,gdiveh3fac);
 					gdiveh3id = Commands->Get_ID(gdiveh3);
 					Attach_Script_Once(gdiveh3,"tcw_domination_vehicle","1");
+					Commands->Set_Player_Type(gdiveh3,-2);
 				}
 			}
 			if (!Commands->Find_Object(gdiveh4id))
@@ -565,6 +583,7 @@
 					Commands->Set_Facing(gdiveh4,gdiveh4fac);
 					gdiveh4id = Commands->Get_ID(gdiveh4);
 					Attach_Script_Once(gdiveh4,"tcw_domination_vehicle","1");
+					Commands->Set_Player_Type(gdiveh4,-2);
 				}
 			}
 			if (!Commands->Find_Object(gdiveh5id))
@@ -577,6 +596,7 @@
 					Commands->Set_Facing(gdiveh5,gdiveh5fac);
 					gdiveh5id = Commands->Get_ID(gdiveh5);
 					Attach_Script_Once(gdiveh5,"tcw_domination_vehicle","1");
+					Commands->Set_Player_Type(gdiveh5,-2);
 				}
 			}
 		}
diff -uwrN sourceold/scripts/tcw_frost.cpp source/scripts/tcw_frost.cpp
--- sourceold/scripts/tcw_frost.cpp	2012-06-09 08:11:12.210937500 +0800
+++ source/scripts/tcw_frost.cpp	2012-07-31 21:54:12.125976500 +0800
@@ -25,6 +25,8 @@
 
 void tcw_frost_node::Created(GameObject *obj)
 {
+	spawnpad1 = Get_Int_Parameter("SpawnPad1ID");
+	spawnpad2 = Get_Int_Parameter("SpawnPad2ID");
 	Commands->Start_Timer(obj,this,60.0f,100100);//start spawncheck for vehicles for nod
 	Commands->Start_Timer(obj,this,60.0f,100101);//start spawncheck for vehicles for gdi
 	int nodeteam = Get_Int_Parameter("PreTeam");
@@ -43,10 +45,12 @@
 		if (Commands->Find_Object(spawnpad1))
 		{
 			Commands->Set_Animation(Commands->Find_Object(spawnpad1),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,0,0,false);
+			Commands->Set_Player_Type(Commands->Find_Object(spawnpad1),0);
 		}
 		if (Commands->Find_Object(spawnpad2))
 		{
 			Commands->Set_Animation(Commands->Find_Object(spawnpad2),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,0,0,false);
+			Commands->Set_Player_Type(Commands->Find_Object(spawnpad2),0);
 		}
 		if (!Commands->Find_Object(nodveh1id))
 		{
@@ -58,6 +62,7 @@
 				Commands->Set_Facing(nodveh1,nodveh1fac);
 				nodveh1id = Commands->Get_ID(nodveh1);
 				Attach_Script_Once(nodveh1,"tcw_domination_vehicle","0");
+				Commands->Set_Player_Type(nodveh1,-2);
 			}
 		}
 		if (!Commands->Find_Object(nodveh2id))
@@ -70,6 +75,7 @@
 				Commands->Set_Facing(nodveh2,nodveh2fac);
 				nodveh2id = Commands->Get_ID(nodveh2);
 				Attach_Script_Once(nodveh2,"tcw_domination_vehicle","0");
+				Commands->Set_Player_Type(nodveh2,-2);
 			}
 		}
 	}
@@ -88,10 +94,12 @@
 		if (Commands->Find_Object(spawnpad1))
 		{
 			Commands->Set_Animation(Commands->Find_Object(spawnpad1),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,1,1,false);
+			Commands->Set_Player_Type(Commands->Find_Object(spawnpad1),1);
 		}
 		if (Commands->Find_Object(spawnpad2))
 		{
 			Commands->Set_Animation(Commands->Find_Object(spawnpad2),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,1,1,false);
+			Commands->Set_Player_Type(Commands->Find_Object(spawnpad2),1);
 		}
 
 		if (!Commands->Find_Object(gdiveh1id))
@@ -104,6 +112,7 @@
 				Commands->Set_Facing(gdiveh1,gdiveh1fac);
 				gdiveh1id = Commands->Get_ID(gdiveh1);
 				Attach_Script_Once(gdiveh1,"tcw_domination_vehicle","1");
+				Commands->Set_Player_Type(gdiveh1,-2);
 			}
 		}
 		if (!Commands->Find_Object(gdiveh2id))
@@ -116,6 +125,7 @@
 				Commands->Set_Facing(gdiveh2,gdiveh2fac);
 				gdiveh2id = Commands->Get_ID(gdiveh2);
 				Attach_Script_Once(gdiveh2,"tcw_domination_vehicle","1");
+				Commands->Set_Player_Type(gdiveh2,-2);
 			}
 		}
 	}
@@ -157,11 +167,13 @@
 				Commands->Set_Animation(obj,"DOM_NODE.DOM_NODE",false,0,0,0,false);
 				if (Commands->Find_Object(spawnpad1))
 				{
+					Commands->Set_Player_Type(Commands->Find_Object(spawnpad1),0);
 					Commands->Set_Animation(Commands->Find_Object(spawnpad1),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,0,0,false);
 				}
 				if (Commands->Find_Object(spawnpad2))
 				{
 					Commands->Set_Animation(Commands->Find_Object(spawnpad2),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,0,0,false);
+					Commands->Set_Player_Type(Commands->Find_Object(spawnpad2),0);
 				}
 
 				if (!Commands->Find_Object(nodveh1id))
@@ -174,6 +186,7 @@
 						Commands->Set_Facing(nodveh1,nodveh1fac);
 						nodveh1id = Commands->Get_ID(nodveh1);
 						Attach_Script_Once(nodveh1,"tcw_domination_vehicle","0");
+						Commands->Set_Player_Type(nodveh1,-2);
 					}
 				}
 				if (!Commands->Find_Object(nodveh2id))
@@ -186,6 +199,7 @@
 						Commands->Set_Facing(nodveh2,nodveh2fac);
 						nodveh2id = Commands->Get_ID(nodveh2);
 						Attach_Script_Once(nodveh2,"tcw_domination_vehicle","0");
+						Commands->Set_Player_Type(nodveh2,-2);
 					}
 				}
 
@@ -208,10 +222,12 @@
 				if (Commands->Find_Object(spawnpad1))
 				{
 					Commands->Set_Animation(Commands->Find_Object(spawnpad1),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,1,1,false);
+					Commands->Set_Player_Type(Commands->Find_Object(spawnpad1),1);
 				}
 				if (Commands->Find_Object(spawnpad2))
 				{
 					Commands->Set_Animation(Commands->Find_Object(spawnpad2),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,1,1,false);
+					Commands->Set_Player_Type(Commands->Find_Object(spawnpad2),1);
 				}
 
 				if (!Commands->Find_Object(gdiveh1id))
@@ -224,6 +240,7 @@
 						Commands->Set_Facing(gdiveh1,gdiveh1fac);
 						gdiveh1id = Commands->Get_ID(gdiveh1);
 						Attach_Script_Once(gdiveh1,"tcw_domination_vehicle","1");
+						Commands->Set_Player_Type(gdiveh1,-2);
 					}
 				}
 				if (!Commands->Find_Object(gdiveh2id))
@@ -236,6 +253,7 @@
 						Commands->Set_Facing(gdiveh2,gdiveh2fac);
 						gdiveh2id = Commands->Get_ID(gdiveh2);
 						Attach_Script_Once(gdiveh2,"tcw_domination_vehicle","1");
+						Commands->Set_Player_Type(gdiveh2,-2);
 					}
 				}
 
@@ -258,6 +276,8 @@
 			if (trigger_neutral_damage)
 			{
 				trigger_neutral_damage = false;
+				Commands->Set_Player_Type(Commands->Find_Object(spawnpad1),-2);
+				Commands->Set_Player_Type(Commands->Find_Object(spawnpad2),-2);
 				Commands->Set_Animation(Commands->Find_Object(spawnpad1),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
 				Commands->Set_Animation(Commands->Find_Object(spawnpad2),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
 				Remove_Script(obj,"tcw_domination_pointgen");
@@ -266,6 +286,10 @@
 				if (owner == 0)
 				{
 					Create_2D_WAV_Sound_Team("ControlPointLost_Nod.wav",0);
+					
+					char lostcp[512];
+					sprintf(lostcp,"Control Point Lost: %s",nodename);
+					Send_Message_Team(0,255,255,255,lostcp);
 					if ( (Commands->Find_Object(nodveh1id)) && (!Get_Vehicle_Driver(Commands->Find_Object(nodveh1id))) )
 					{
 						Commands->Apply_Damage(Commands->Find_Object(nodveh1id),99999.0f,"Steel",obj);		nodveh1id = 0;
@@ -278,6 +302,9 @@
 				else if (owner == 1)
 				{
 					Create_2D_WAV_Sound_Team("ControlPointLost_GDI.wav",1);
+					char lostcp[512];
+					sprintf(lostcp,"Control Point Lost: %s",nodename);
+					Send_Message_Team(1,255,255,255,lostcp);
 					if ( (Commands->Find_Object(gdiveh1id)) && (!Get_Vehicle_Driver(Commands->Find_Object(gdiveh1id))) )
 					{
 						Commands->Apply_Damage(Commands->Find_Object(gdiveh1id),99999.0f,"Steel",obj);		gdiveh1id = 0;
@@ -308,6 +335,7 @@
 					Commands->Set_Facing(nodveh1,nodveh1fac);
 					nodveh1id = Commands->Get_ID(nodveh1);
 					Attach_Script_Once(nodveh1,"tcw_domination_vehicle","0");
+					Commands->Set_Player_Type(nodveh1,-2);
 				}
 			}
 			if (!Commands->Find_Object(nodveh2id))
@@ -320,6 +348,7 @@
 					Commands->Set_Facing(nodveh2,nodveh2fac);
 					nodveh2id = Commands->Get_ID(nodveh2);
 					Attach_Script_Once(nodveh2,"tcw_domination_vehicle","0");
+					Commands->Set_Player_Type(nodveh2,-2);
 				}
 			}
 		}
@@ -339,6 +368,7 @@
 					Commands->Set_Facing(gdiveh1,gdiveh1fac);
 					gdiveh1id = Commands->Get_ID(gdiveh1);
 					Attach_Script_Once(gdiveh1,"tcw_domination_vehicle","1");
+					Commands->Set_Player_Type(gdiveh1,-2);
 				}
 			}
 			if (!Commands->Find_Object(gdiveh2id))
@@ -351,6 +381,7 @@
 					Commands->Set_Facing(gdiveh2,gdiveh2fac);
 					gdiveh2id = Commands->Get_ID(gdiveh2);
 					Attach_Script_Once(gdiveh2,"tcw_domination_vehicle","1");
+					Commands->Set_Player_Type(gdiveh2,-2);
 				}
 			}
 		}
diff -uwrN sourceold/scripts/tcw_functions.cpp source/scripts/tcw_functions.cpp
--- sourceold/scripts/tcw_functions.cpp	2012-06-09 08:11:12.365234300 +0800
+++ source/scripts/tcw_functions.cpp	2012-07-31 21:54:12.174804600 +0800
@@ -30,7 +30,7 @@
 
 bool Is_TCW_Engineer(GameObject *Obj)
 {
-	if ( strcmp(Commands->Get_Preset_Name(Obj),"TCW_Nod_Saboteur") == 0 || strcmp(Commands->Get_Preset_Name(Obj),"TCW_Nod_Saboteur_Low") == 0 || strcmp(Commands->Get_Preset_Name(Obj),"TCW_GDI_Engineer") == 0 || strcmp(Commands->Get_Preset_Name(Obj),"TCW_GDI_Engineer_Low") == 0 )
+	if ( strcmp(Commands->Get_Preset_Name(Obj),"TCW_Nod_Saboteur") == 0 || strcmp(Commands->Get_Preset_Name(Obj),"TCW_Nod_Saboteur_Low") == 0 || strcmp(Commands->Get_Preset_Name(Obj),"TCW_GDI_Engineer") == 0 || strcmp(Commands->Get_Preset_Name(Obj),"TCW_GDI_Engineer_Low") == 0 || strcmp(Commands->Get_Preset_Name(Obj),"TCW_GDI_Engineer_Coop") == 0 || strcmp(Commands->Get_Preset_Name(Obj),"TCW_Nod_Saboteur_Coop") == 0)
 		return true;
 	else
 		return false;
diff -uwrN sourceold/scripts/tcw_game.cpp source/scripts/tcw_game.cpp
--- sourceold/scripts/tcw_game.cpp	2012-06-09 08:11:12.311523400 +0800
+++ source/scripts/tcw_game.cpp	2012-07-31 21:54:12.225585900 +0800
@@ -70,11 +70,11 @@
 
 void tcw_Map_Intro::Created(GameObject *obj)
 {
-	Commands->Start_Timer(obj,this,10.0f,251);
-	Commands->Start_Timer(obj,this,13.0f,252);
-	Commands->Start_Timer(obj,this,16.0f,253);
-	Commands->Start_Timer(obj,this,19.0f,254);
-	Commands->Start_Timer(obj,this,22.0f,255);
+	Commands->Start_Timer(obj,this,15.0f,251);
+	Commands->Start_Timer(obj,this,18.0f,252);
+	Commands->Start_Timer(obj,this,21.0f,253);
+	Commands->Start_Timer(obj,this,24.0f,254);
+	Commands->Start_Timer(obj,this,27.0f,255);
 }
 void tcw_Map_Intro::Timer_Expired(GameObject *obj, int number)
 {
@@ -333,6 +333,13 @@
 	}
 }
 
+void tcw_snipe_only_building::Created(GameObject *obj)
+{
+	Set_Damage_Points(obj,0.0f);
+	Set_Skin(obj,"Blamo");
+}
+
+ScriptRegistrant<tcw_snipe_only_building> tcw_snipe_only_building_Registrant("tcw_snipe_only_building","");
 ScriptRegistrant<tcw_Spawner_Enable_Timer> tcw_Spawner_Enable_Timer_Registrant("tcw_Spawner_Enable_Timer","Enable_After_Seconds=1000:float,SpawnerID=0:int");
 ScriptRegistrant<tcw_destroyed_send_custom> tcw_destroyed_send_custom_Registrant("tcw_destroyed_send_custom","Message=1000:int,SendID=1000:int,Param=1:int");
 ScriptRegistrant<tcw_dm_map_tech1> tcw_dm_map_tech1_Registrant("tcw_dm_map_tech1","");
diff -uwrN sourceold/scripts/tcw_game.h source/scripts/tcw_game.h
--- sourceold/scripts/tcw_game.h	2012-06-09 08:11:12.182617100 +0800
+++ source/scripts/tcw_game.h	2012-07-31 21:54:12.061523400 +0800
@@ -77,6 +77,10 @@
 	void Timer_Expired(GameObject *obj, int number);
 };
 
+class tcw_snipe_only_building : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
 
 
 
diff -uwrN sourceold/scripts/tcw_mcv_escort.cpp source/scripts/tcw_mcv_escort.cpp
--- sourceold/scripts/tcw_mcv_escort.cpp	2012-06-09 08:11:12.375976500 +0800
+++ source/scripts/tcw_mcv_escort.cpp	2012-07-31 21:54:12.134765600 +0800
@@ -36,7 +36,8 @@
 			Commands->Set_Animation(obj,"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,1,1,false);
 			Console_Input("amsg The MCV was successfully escorted to the GDI Base.");
 			Commands->Start_Timer(obj,this,5.5f,100);
-			Remove_Script(sender,"tcw_mcv_escort_mcv");
+			Remove_Script(sender,"tcw_mcv_escort_mcv");//sender is wrong, should be the mcv not the sender
+			//set skin of mcv to blamo
 		}
 	}
 }
